require "util"

script.on_event(defines.events.on_tick, function(event)
	TickTanks(event)
end)

script.on_event({
    defines.events.on_built_entity, 
    defines.events.on_robot_built_entity
  }, 
  function(event)
    if event.created_entity.name == "liquids-generator" then
      RememberTank(event.created_entity)
    end
  end)

script.on_event({
    defines.events.on_preplayer_mined_item, 
    defines.events.on_robot_pre_mined, 
    defines.events.on_entity_died
  }, 
  function(event)
  end)

function RememberTank(entity)
  if global.Liquids_Generators == nil then
    global.Liquids_Generators = {}
  end
  local liquids_generator = entity
  table.insert(global.Liquids_Generators, liquids_generator)
end

function TickTanks(event)
	if global.Liquids_Generators ~= nil then 
		for i = #global.Liquids_Generators,1,-1 do
      local liquids_generator = global.Liquids_Generators[i]
			if liquids_generator.valid then
        if liquids_generator.fluidbox[1] ~= nil then
          local amount = liquids_generator.fluidbox[1].amount
          local fluid = liquids_generator.fluidbox[1].type
          liquids_generator.fluidbox[1] = {
            ["type"] = fluid,
            ["amount"] = amount + 1
          }
        end
			else --liquids_generator.valid == false
        table.remove(global.Liquids_Generators, i)
      end
		end
	end
end
